"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = outerHTML;

var _transaction = _interopRequireWildcard(require("./transaction"));

var _types = require("./util/types");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @param {Mount} mount
 * @param {ValidInput} input
 * @param {TransactionConfig} config
 *
 * @return {Promise<Transaction> | unknown}
 */
function outerHTML(mount, input = _types.EMPTY.STR, config = {}) {
  config.inner = false;
  config.executeScripts = 'executeScripts' in config ? config.executeScripts : true;
  config.tasks = config.tasks || _transaction.defaultTasks;
  return _transaction.default.create(mount, input, config).start();
}

module.exports = exports.default;