"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parseNewTree;

var _parse = _interopRequireDefault(require("../util/parse"));

var _create = _interopRequireDefault(require("../tree/create"));

var _transaction = _interopRequireDefault(require("../transaction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @param {Transaction} transaction
 */
function parseNewTree(transaction) {
  const {
    state,
    input,
    config: options
  } = transaction;
  const {
    measure
  } = state;
  const {
    inner
  } = options;

  if (typeof input === 'string') {
    measure('parsing input for new tree');
    const {
      childNodes
    } = (0, _parse.default)(input, undefined, options);
    let vTree; // If we are dealing with innerHTML, use all the Nodes.

    if (inner) {
      vTree = (0, _create.default)(childNodes);
    } // If we are dealing with outerHTML, use the first element or the element
    // itself.
    else {
      vTree = (0, _create.default)(childNodes[0] || childNodes);
    }

    if (vTree) {
      transaction.newTree = vTree;
    }

    measure('parsing input for new tree');
  }
}

module.exports = exports.default;