"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = hasModule;

var _global = _interopRequireDefault(require("./global"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Safely lookup if we have access to a SCRIPT element for testing module support.
const element =
/** @type {any} */
_global.default.document ?
/** @type {HTMLScriptElement} */
document.createElement('script') : null;
/**
 * Determines if the executing environment supports modules or not.
 *
 * @return {Boolean} - Whether or not modules are supported.
 */

function hasModule() {
  return Boolean(element && 'noModule' in element);
}

module.exports = exports.default;