"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _transaction = _interopRequireWildcard(require("../transaction"));

var _create = _interopRequireDefault(require("../node/create"));

var _sync = _interopRequireDefault(require("../tree/sync"));

var _decodeEntities = _interopRequireDefault(require("./decode-entities"));

var _escape = _interopRequireDefault(require("./escape"));

var _makeMeasure = _interopRequireDefault(require("./make-measure"));

var memory = _interopRequireWildcard(require("./memory"));

var _pool = _interopRequireDefault(require("./pool"));

var _process = _interopRequireDefault(require("./process"));

var _config = require("./config");

var _types = require("./types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const caches = {
  StateCache: _types.StateCache,
  NodeCache: _types.NodeCache,
  TransitionCache: _types.TransitionCache,
  MiddlewareCache: _types.MiddlewareCache,
  CreateTreeHookCache: _types.CreateTreeHookCache,
  CreateNodeHookCache: _types.CreateNodeHookCache,
  SyncTreeHookCache: _types.SyncTreeHookCache,
  ReleaseHookCache: _types.ReleaseHookCache,
  ParseHookCache: _types.ParseHookCache
};

var _default =
/** @type {Internals} */
_objectSpread({
  // Utils.
  decodeEntities: _decodeEntities.default,
  escape: _escape.default,
  makeMeasure: _makeMeasure.default,
  memory,
  Pool: _pool.default,
  process: _process.default,
  PATCH_TYPE: _types.PATCH_TYPE,
  globalConfig: _config.globalConfig,
  // Core.
  createNode: _create.default,
  syncTree: _sync.default,
  // Tasks.
  Transaction: _transaction.default,
  defaultTasks: _transaction.defaultTasks,
  tasks: _transaction.tasks
}, caches);

exports.default = _default;
module.exports = exports.default;