/**
 * Request a configuration value by key. Provide a defaultValue always to ensure
 * proper type lookup. An overrides object can be passed to shortcircuit
 * lookups. Keys are looked up with a DIFF_ prefix when in the query string or
 * environment variable.
 *
 * @param {string} name
 * @param {unknown} defaultValue
 * @param {string} type
 * @param {{[name: string]: any}=} overrides
 *
 * @return {unknown}
 */
export default function getConfig(name: string, defaultValue: unknown, type?: string, overrides?: {
    [name: string]: any;
} | undefined): unknown;
/** @type {Config} */
export const globalConfig: Config;
import { Config } from "./types";
